Index: main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 6354)
+++ main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 6355)
@@ -184,6 +184,4 @@
     def update(self):
         datepicker.need() # Enable jQuery datepicker in date fields.
-        #from waeup.sirp.browser.resources import jqueryui
-        #jqueryui.need()
         return super(ApplicantsContainerAddFormPage, self).update()
 
@@ -505,5 +503,6 @@
 
     def getCourseAdmitted(self):
-        """Return link, title and code in html format to the certificate admitted.
+        """Return link, title and code in html format to the certificate
+           admitted.
         """
         course_admitted = self.context.course_admitted
@@ -558,5 +557,6 @@
         """
         allowed_transitions = self.wf_info.getManualTransitions()
-        return [dict(name=x, title=y) for x, y in allowed_transitions]
+        return [dict(name='', title='No transition')] +[
+            dict(name=x, title=y) for x, y in allowed_transitions]
 
     @grok.action('Save')
Index: main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/form_edit.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/form_edit.pt	(revision 6354)
+++ main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/form_edit.pt	(revision 6355)
@@ -46,21 +46,23 @@
         </tr>
       </tal:block>
-        <tr tal:condition="view/manage_applications">
+      <tr tal:condition="view/manage_applications">
         <td class="label"><label>Application Transition:</label></td>
         <td>
-            <select id="transition" name="transition">
-                <option tal:repeat="transition view/getTransitions" tal:attributes="value transition/name">
-                    <span tal:replace="transition/title">TRANSITIONTITLE
-                    </span>
-                </option>
-            </select>
+          <select id="transition" name="transition">
+            <option tal:repeat="transition view/getTransitions"
+                    tal:attributes="value transition/name">
+              <span tal:replace="transition/title">TRANSITIONTITLE</span>
+            </option>
+          </select>
         </td>
-        </tr>
+      </tr>
     </tbody>
   </table>
 
   <p tal:condition="not: view/manage_applications">
-    <input class="checkboxType" id="confirm_passport" name="confirm_passport" type="checkbox" value="True"/>
-    I confirm that the Passport Photograph uploaded on this form is a true picture of me.
+    <input class="checkboxType" id="confirm_passport" name="confirm_passport"
+           type="checkbox" value="True"/>
+    I confirm that the Passport Photograph uploaded on this form is a
+    true picture of me.
   </p>
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/applicants/workflow.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/applicants/workflow.py	(revision 6354)
+++ main/waeup.sirp/trunk/src/waeup/sirp/applicants/workflow.py	(revision 6355)
@@ -7,6 +7,5 @@
 from waeup.sirp.applicants.interfaces import IApplicantBaseData
 from waeup.sirp.interfaces import IObjectHistory, IWAeUPWorkflowInfo
-from waeup.sirp.workflow import (
-    WAeUPWorkflow, WAeUPWorkflowInfo, NULL_TRANSITION)
+from waeup.sirp.workflow import WAeUPWorkflow, WAeUPWorkflowInfo
 
 INITIALIZED = 'initialized'
@@ -18,6 +17,4 @@
 
 APPLICATION_TRANSITIONS = (
-    NULL_TRANSITION,
-
     Transition(
         transition_id = 'init',
Index: main/waeup.sirp/trunk/src/waeup/sirp/workflow.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/workflow.py	(revision 6354)
+++ main/waeup.sirp/trunk/src/waeup/sirp/workflow.py	(revision 6355)
@@ -30,14 +30,4 @@
 from zope.security.management import getInteraction
 from waeup.sirp.interfaces import IWAeUPWorkflowInfo
-
-#: A transition that is not a real transition. Use it when you want a
-#: transition that does not change the state of the connected object.
-NULL_TRANSITION = Transition(
-    transition_id = '',
-    title = 'No transition',
-    source = None,
-    condition = NullCondition,
-    msg = '',
-    destination = None,)
 
 class WAeUPWorkflow(Workflow):