Index: main/waeup.sirp/trunk/src/waeup/sirp/app.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/app.py	(revision 6360)
+++ main/waeup.sirp/trunk/src/waeup/sirp/app.py	(revision 6361)
@@ -21,4 +21,5 @@
     IDataCenterStorageMovedEvent, IObjectUpgradeEvent, )
 from waeup.sirp.users import UserContainer
+from waeup.sirp.utils.helpers import attrs_to_fields
 
 class University(grok.Application, grok.Container):
@@ -32,49 +33,4 @@
         PluggableAuthentication, provides = IAuthentication,
         setup = setup_authentication,)
-
-    # The name of the university.
-    name=u'Sample University'
-
-    # The default layout.
-    skin=u'gray waeup theme'
-
-    # The default frontpage.
-    frontpage= """
-This is the default frontpage of the portal written
-in `reStructuredText (reST)
-<http://docutils.sourceforge.net/docs/user/rst/quickref.html>`_
-markup language.
-
-Some more reST examples for getting started:
-
-1. Heading
-----------
-
-Text
-
-1.2 Heading
-...........
-
-Text
-
-2. Heading
-----------
-
-Text
-
-2.1 Heading
-...........
-
-Text
-
-2.2 Heading
-...........
-
-Text
-
-"""
-
-    # The default title.
-    title=u'Welcome to the Student Information and Registration Portal of %s' % name
 
     @property
@@ -97,12 +53,15 @@
         return logger
 
-
-    def __init__(self, name=name, skin=skin, title=title,
-                 frontpage=frontpage, **kw):
+    def __init__(self, name=None, skin=None, title=None,
+                 frontpage=None, **kw):
         super(University, self).__init__(**kw)
-        self.name = name
-        self.skin = skin
-        self.title = title
-        self.frontpage = frontpage
+        if name is not None:
+            self.name = name
+        if skin is not None:
+            self.skin = skin
+        if title is not None:
+            self.title = title
+        if frontpage is not None:
+            self.frontpage = frontpage
         self.setup()
 
@@ -162,4 +121,5 @@
         logger.addHandler(handler)
         return logger
+attrs_to_fields(University)
 
 @grok.subscribe(IDataCenter, IDataCenterStorageMovedEvent)
Index: main/waeup.sirp/trunk/src/waeup/sirp/frontpage.rst
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/frontpage.rst	(revision 6361)
+++ main/waeup.sirp/trunk/src/waeup/sirp/frontpage.rst	(revision 6361)
@@ -0,0 +1,31 @@
+This is the default frontpage of the portal written
+in `reStructuredText (reST)
+<http://docutils.sourceforge.net/docs/user/rst/quickref.html>`_
+markup language.
+
+Some more reST examples for getting started:
+
+1. Heading
+==========
+
+Text
+
+1.2 Heading
+-----------
+
+Text
+
+2. Heading
+==========
+
+Text
+
+2.1 Heading
+-----------
+
+Text
+
+2.2 Heading
+-----------
+
+Text
Index: main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py	(revision 6360)
+++ main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py	(revision 6361)
@@ -1,4 +1,5 @@
 ##
 ## interfaces.py
+import os
 from hurry.workflow.interfaces import IWorkflow, IWorkflowInfo
 from zc.sourcefactory.basic import BasicSourceFactory
@@ -8,4 +9,7 @@
 from zope.interface import Interface, Attribute, implements
 from zope.schema.vocabulary import SimpleVocabulary, SimpleTerm
+
+default_frontpage = u'' + open(os.path.join(
+        os.path.dirname(__file__), 'frontpage.rst'), 'rb').read()
 
 class FatalCSVError(Exception):
@@ -63,5 +67,5 @@
     name = schema.TextLine(
         title = u'Name of University',
-        default = u'Unnamed',
+        default = u'Sample University',
         required = True,
         )
@@ -69,5 +73,6 @@
     title = schema.TextLine(
         title = u'Title of frontpage',
-        default = u'No Title',
+        default = u'Welcome to the Student Information and Registration ' +
+                  u'Portal of Sample University',
         required = False,
         )
@@ -83,5 +88,5 @@
         title = u'Content in reST format',
         required = False,
-        default = u'This is the SIRP frontpage.'
+        default = default_frontpage,
         )
 