Index: /main/waeup.sirp/branches/accesscodes-with-workflow/src/waeup/sirp/browser/pages.py
===================================================================
--- /main/waeup.sirp/branches/accesscodes-with-workflow/src/waeup/sirp/browser/pages.py	(revision 6404)
+++ /main/waeup.sirp/branches/accesscodes-with-workflow/src/waeup/sirp/browser/pages.py	(revision 6405)
@@ -37,5 +37,5 @@
     ILocalRolesAssignable, DuplicationError)
 from waeup.sirp.permissions import get_users_with_local_roles, getRoles
-from waeup.sirp.university.catalog import search
+#from waeup.sirp.university.catalog import search
 from waeup.sirp.university.vocabularies import course_levels
 from waeup.sirp.users import LocalRoleSetEvent
@@ -347,22 +347,22 @@
 
 
-class SearchPage(WAeUPPage):
-    grok.context(IUniversity)
-    grok.name('search')
-    grok.template('searchpage')
-    grok.require('waeup.manageUniversity')
-    title = u"Site Search"
-    pnav = 2
-
-    def update(self, *args, **kw):
-        form = self.request.form
-        self.hitlist = []
-        self.query = ''
-        if not 'query' in form:
-            return
-        query = form['query']
-        self.query = query
-        self.hitlist = search(query=self.query, view=self)
-        return
+#class SearchPage(WAeUPPage):
+#    grok.context(IUniversity)
+#    grok.name('search')
+#    grok.template('searchpage')
+#    grok.require('waeup.manageUniversity')
+#    title = u"Site Search"
+#    pnav = 2
+
+#    def update(self, *args, **kw):
+#        form = self.request.form
+#        self.hitlist = []
+#        self.query = ''
+#        if not 'query' in form:
+#            return
+#        query = form['query']
+#        self.query = query
+#        self.hitlist = search(query=self.query, view=self)
+#        return
 
 #
Index: /main/waeup.sirp/branches/accesscodes-with-workflow/src/waeup/sirp/browser/test_permissions.py
===================================================================
--- /main/waeup.sirp/branches/accesscodes-with-workflow/src/waeup/sirp/browser/test_permissions.py	(revision 6404)
+++ /main/waeup.sirp/branches/accesscodes-with-workflow/src/waeup/sirp/browser/test_permissions.py	(revision 6405)
@@ -20,5 +20,5 @@
 manager_pages = [
     # The pages that should only be accessible by manager...
-    '/@@manage', '/@@administration', '/@@searchstudent', '/@@search',
+    '/@@manage', '/@@administration', '/@@searchstudent',
     '/users/@@index', '/users/@@add', '/users/alice/@@index',
     '/datacenter/@@index', '/datacenter/@@upload', '/datacenter/@@import1',
Index: /main/waeup.sirp/branches/accesscodes-with-workflow/src/waeup/sirp/university/catalog.py
===================================================================
--- /main/waeup.sirp/branches/accesscodes-with-workflow/src/waeup/sirp/university/catalog.py	(revision 6404)
+++ /main/waeup.sirp/branches/accesscodes-with-workflow/src/waeup/sirp/university/catalog.py	(revision 6405)
@@ -92,28 +92,28 @@
     return
 
-class CourseQueryResultItem(QueryResultItem):
-    def __init__(self, context, view):
-        self.context = context
-        self.url = view.url(context)
-        self.title = "COURSE: " + context.title
-        self.description = 'code: %s' % context.code
+#class CourseQueryResultItem(QueryResultItem):
+#    def __init__(self, context, view):
+#        self.context = context
+#        self.url = view.url(context)
+#        self.title = "COURSE: " + context.title
+#        self.description = 'code: %s' % context.code
 
-def search(query=None, view=None):
-    if not query:
-        return []
-    cat = getUtility(ICatalog, name='courses_catalog')
-    results = list(cat.searchResults(code=(query, query)))
+#def search(query=None, view=None):
+#    if not query:
+#        return []
+#    cat = getUtility(ICatalog, name='courses_catalog')
+#    results = list(cat.searchResults(code=(query, query)))
 
-    hitlist = []
-    results = Query().searchResults(
-        Eq(('courses_catalog', 'code'), query))
-    for result in results:
-        hitlist.append(CourseQueryResultItem(result, view=view))
+#    hitlist = []
+#    results = Query().searchResults(
+#        Eq(('courses_catalog', 'code'), query))
+#    for result in results:
+#        hitlist.append(CourseQueryResultItem(result, view=view))
 
-    results = Query().searchResults(
-        Text(('courses_catalog', 'title'), query))
+#    results = Query().searchResults(
+#        Text(('courses_catalog', 'title'), query))
 
-    for result in results:
-        hitlist.append(CourseQueryResultItem(result, view=view))
+#    for result in results:
+#        hitlist.append(CourseQueryResultItem(result, view=view))
 
-    return hitlist
+#    return hitlist